; GUI #
include win64a.inc
; --------------- 
WINDOWWIDTH  = 800
WINDOWHEIGHT = 600
ANTIALIASED_QUALITY = 4
cnt1	equ cnt
cnt2	equ cnt+4
.code
WinMain	proc
local	msg:MSG

	xor	ebx,ebx
        mov	edi,offset szClassName
        mov	esi,IMAGE_BASE
        mov	ecx,offset FileName
	invoke	LoadCursorFromFile
        push	rax	;hIconSm
	push	rdi	;lpszClassName
	push	rbx	;lpszMenuName
	push	COLOR_WINDOWTEXT+1;hbrBackground
	push	rax	;hCursor
	push	rax        ;hIcon
	push	rsi	;hInstance
	push	rbx        ;cbClsExtra & cbWndExtra
	pushaddr WndProc;lpfnWndProc
	mov	rax,(CS_HREDRAW or CS_VREDRAW or CS_OWNDC)shl 32 \
	or (sizeof WNDCLASSEX)
	push	rax	;cbSize & style
    	invoke	RegisterClassEx,esp	;addr WNDCLASSEX
	
	push	rbx
	push	rsi	;rsi = 400000h
	shl	esi,9	;rsi = CW_USEDEFAULT
	push	rbx
	push	rbx
	push	WINDOWHEIGHT
	push	WINDOWWIDTH
	push	rsi
	push	rsi
	sub	esp,20h
    	invoke	CreateWindowEx,0,edi,edi,WS_OVERLAPPEDWINDOW or \
	WS_CLIPCHILDREN or WS_CLIPSIBLINGS or WS_VISIBLE
; 
    	lea	edi,msg
@@:	invoke	GetMessage,edi,0,0,0	
	cmp	msg.wParam,VK_ESCAPE;user press 'Esc'?
        je	wmDESTROY
	invoke	DispatchMessage,edi
	jmp	@b
WinMain endp
WndProc	proc	hWin:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD
local	ps:PAINTSTRUCT
local	w:dword
local	h:dword
local	buffer[50]:byte
local	font:dword
local	oldfont:dword

        mov	hWin,rcx
        xor	ebx,ebx

        cmp	edx,WM_CREATE
	je      wmCREATE
        cmp	edx,WM_SIZE
	je      wmSIZE
        cmp	edx,WM_PAINT
	je      wmPAINT
        cmp	edx,WM_DESTROY
	je      wmDESTROY     
        cmp	edx,WM_TIMER
	je      wmTIMER
default:leave
	jmp	NtdllDefWindowProc_
wmDESTROY::invoke wglMakeCurrent,0,0
	invoke	wglDeleteContext,hRC
	invoke	ReleaseDC,hWin,hDC
	invoke	KillTimer,hWin,10	
	invoke	RtlExitUserProcess,NULL
;----------------------------------------------
wmTIMER:movaps	xmm0,cnt
	addps	xmm0,delta
	movaps	cnt,xmm0
	invoke	InvalidateRect,,0,0
        jmp	wmBYE
wmCREATE:invoke	GetDC ;  
	mov	hDC,rax
;    OpenGL ( OpenGL   
;)  
        mov	edx,offset PixFrm
	invoke	ChoosePixelFormat,eax
;  
	mov	r8d,offset PixFrm
	invoke	SetPixelFormat,hDC,eax
;     OpenGL
	invoke	wglCreateContext,hDC
	mov	hRC,rax
;   
	invoke	wglMakeCurrent,hDC,eax
	invoke	SetTimer,hWin,10,25,0;  #10  25mSec
;-------------------------------------------------------
	invoke	glShadeModel,GL_SMOOTH;smooth shading
	cvtss2sd xmm0,const1
	invoke	glClearDepth;   
	invoke	glEnable,GL_DEPTH_TEST ;  
	invoke	glDepthFunc,GL_LEQUAL ;  
;     ()
	invoke	glHint,GL_PERSPECTIVE_CORRECTION_HINT,GL_NICEST
; Create the outline font
	invoke	glGenLists,96	; Create storage for 256 Characters
	mov	_Font_List,eax
	pushaddr aFontName
	push	FF_DONTCARE or DEFAULT_PITCH	;Family And Pitch
	push	ANTIALIASED_QUALITY		;Output Quality
	push	CLIP_DEFAULT_PRECIS		;Clipping Precision
	push	OUT_TT_PRECIS			;Output Precision
	push	ANSI_CHARSET			;Character Set Identifier
	push	rbx                             ;Strikeout
	push	rbx                             ;Underline
	push	rbx                             ;Italic
	push	FW_BOLD                         ;Font Weight
	sub	esp,20h
	invoke	CreateFont,-24,0,0,0;Height,Width,Angle Of Escapement,Orientation Angle
	mov	font,eax
	invoke	SelectObject,hDC,eax
        mov	oldfont,eax
	mov	r9d,_Font_List
        invoke	wglUseFontBitmapsA,hDC,32,96
	mov	edx,oldfont
	invoke	SelectObject,hDC
	mov	ecx,font
	invoke	DeleteObject
	
        mov	r9d,(WINDOWHEIGHT shl 16)or WINDOWWIDTH 
wmSIZE:; --------------- Resize the scene
	movzx	r8,r9w
	mov	w,r8d
	shr	r9d,16
	mov	h,r9d
	invoke	glViewport,0,0;     
        invoke	glMatrixMode,GL_PROJECTION;     
	invoke	glLoadIdentity;		   
;    , ..    (  glcall ..     8 )
	movq	xmm3,constd100
	movq	xmm2,constd0_1
	cvtsi2sd xmm1,w
	cvtsi2sd xmm0,h
	divsd	xmm1,xmm0
	movq	xmm0,constd45
	invoke	gluPerspective
;    
	invoke	glMatrixMode,GL_MODELVIEW;     ()
	invoke	glLoadIdentity		;   
        jmp	wmBYE
wmPAINT:; No pending messages: draw the scene
	lea	edx,ps
	invoke	BeginPaint
; --------------- Display the scene
;  
	invoke	glClear,GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT;clear screen before drawing
        invoke	glLoadIdentity
	xorps	xmm2,xmm2
	subss	xmm2,const1
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
        invoke	glTranslatef
	movd	xmm0,cnt1
	addss	xmm0,cnt2
	invoke	cosf
	mulss	xmm0,const_0_5
	addss	xmm0,const1
	movss	xmm8,xmm0
	movd	xmm0,cnt2
	invoke	sinf 
	movss	xmm7,xmm0
	movd	xmm0,cnt1
	invoke	cosf
	movss	xmm6,xmm0
	movss	xmm2,xmm8
	movss	xmm1,xmm7
	invoke	glColor3f 
	movss	xmm1,xmm7
	mulss	xmm1,const0_35

	movss	xmm0,xmm6
	mulss	xmm0,const0_05
	addss	xmm0,const_0_45

	invoke	glRasterPos2f
	mov	r8d,offset cnt
	mov	edx,offset fmt
	lea	ecx,buffer
	invoke	vsprintf
;---------------------------------------
	invoke	glPushAttrib,GL_LIST_BIT 
	mov	ecx,_Font_List
	sub	ecx,32
    	invoke	glListBase
	lea	ecx,buffer
	invoke	lstrlen
	lea	r8d,buffer
	invoke	glCallLists,eax,GL_UNSIGNED_BYTE
	invoke	glPopAttrib
;---------------------------------------------	
        invoke  glFlush
;   
        invoke	SwapBuffers,hDC
        lea	edx,ps
	invoke  EndPaint,hWin
wmBYE:	leave
	retn	
WndProc	endp
;---------------------------------------------------------
hDC	dq	?
hRC	dq	?
PixFrm	label	PIXELFORMATDESCRIPTOR 
	nSize             dw	sizeof PIXELFORMATDESCRIPTOR
  	nVersion          dw	1
  	dwFlags           dd	PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER or PFD_DRAW_TO_WINDOW
  	iPixelType        db	PFD_TYPE_RGBA
  	cColorBits        db	32;Select Our Color Depth
  	cRedBits          db	0
  	cRedShift         db	0
  	cGreenBits        db	0
  	cGreenShift       db	0
  	cBlueBits         db	0
  	cBlueShift        db	0;Color Bits Ignored
  	cAlphaBits        db	0;No Alpha Buffer
  	cAlphaShift       db	0;Shift Bit Ignored
  	cAccumBits        db	0;No Accumulation Buffer
  	cAccumRedBits     db	0
  	cAccumGreenBits   db	0
  	cAccumBlueBits    db	0
  	cAccumAlphaBits   db	0;Accumulation Bits Ignored
  	cDepthBits        db	16;16Bit Z-Buffer (Depth Buffer)
  	cStencilBits      db	0;No Stencil Buffer
  	cAuxBuffers       db	0;No Auxiliary Buffer
  	iLayerType        db	PFD_MAIN_PLANE;Main Drawing Layer
  	bReserved         db	0;Reserved
  	dwLayerMask       dd	0
  	dwVisibleMask     dd	0
  	dwDamageMask      dd	0;Layer Masks Ignored

szClassName	db "NeHe lesson#13 - Bitmap Fonts",0
FileName	db "br_Rabbit3.cur",0
aFontName	db "Courier New",0; "Times New Roman",0;
_Font_List	dd ?; Font base
fmt		db "Active OpenGL Text With NeHe - %4.7f",0
;-----------------------------
;float
const0_05	dd 0.05
const0_35	dd 0.35 
const_0_45	dd -0.45 
const_0_5	dd -0.5
const1		dd 1.0
;double
constd0_1	dq 0.1
constd45	dq 45.0
constd100	dq 100.0
align 16
cnt		dd     0,    0, 0, 0
delta		dd 0.051,0.005, 0, 0
end